Sketcher SketchObject: Difference between revisions

From FreeCAD Documentation
(Removed Attachment property group. These are inherited properties and should not be mentioned.)
(Reordering the properties...)
Line 52: Line 52:
=== Data === <!--T:12-->
=== Data === <!--T:12-->


<!--T:14-->
{{TitleProperty|Sketch}}
{{TitleProperty|Sketch}}

* {{PropertyData|Geometry|GeometryList|Hidden}}: a list of Part geometries that exist inside the sketch.
* {{PropertyData|Constraints|}}: named constraints, if they exist; otherwise it is an empty list {{incode|[]}}.
* {{PropertyData|Constraints|}}: named constraints, if they exist; otherwise it is an empty list {{incode|[]}}.

==== Hidden properties Data ==== <!--T:25-->

<!--T:27-->
{{TitleProperty|Base}}

<!--T:28-->
* {{PropertyData|Proxy|PythonObject}}: a custom class associated with this object. This only exists for the [[Python|Python]] version. See [[Sketcher_SketchObject#Scripting|Scripting]].

<!--T:29-->
{{TitleProperty|Sketch}}

<!--T:30-->
* {{PropertyData|Geometry|GeometryList}}: a list of Part geometries that exist inside the sketch.
* {{PropertyData|External Geometry|LinkSubList}}: a list of Part geometries outside this Sketch that are used for reference.
* {{PropertyData|External Geometry|LinkSubList}}: a list of Part geometries outside this Sketch that are used for reference.
* {{PropertyData|Fully Constrained|Bool}}: (read-only) if it is {{TRUE}}, the sketch is fully constrained.


=== View === <!--T:15-->
=== View === <!--T:15-->

Revision as of 11:33, 17 February 2022

Introduction

A Sketcher SketchObject, or formally a Sketcher::SketchObject, is the base element to create 2D objects with the Sketcher Workbench.

The Sketcher::SketchObject is derived from Part Part2DObject, which means it is a Part Feature object specialized for 2D geometry. Like Part2DObject, the SketchObject can be attached to planes and faces. In addition, the SketchObject can handle geometrical constraints of the lines and curves that are drawn within it.

Simplified diagram of the relationships between the core objects in FreeCAD. The Sketcher::SketchObject class is specialized for 2D shapes, and additionally it includes an extension to handle geometrical constraints of its elements.

Usage

  1. Switch to the Sketcher Workbench.
  2. Press Sketcher NewSketch.
  3. Select a Sketch orientation: XY-plane, XZ-plane, or YZ-plane. Optionally also choose Reverse direction, and give an Offset value.
  4. Press OK.

Although the SketchObject can be used by itself to draw on a plane, it is most commonly used in conjunction with the PartDesign Workbench to create extruded solids.

  1. Switch to the PartDesign Workbench.
  2. Press PartDesign Body.
  3. Press PartDesign NewSketch.
  4. Select feature: XY_Plane (Base plane), XZ_Plane (Base plane), or YZ_Plane (Base plane).
  5. Press OK.

Properties

See Property for all property types that scripted objects can have.

The Sketcher SketchObject (Sketcher::SketchObject class) is derived from the Part Part2DObject (Part::Part2DObject class) and inherits all its properties.

The Sketcher SketchObject also has the following additional properties in the property editor. Hidden properties can be shown by using the Show all command in the context menu of the property editor.

Data

Sketch

  • Data (Hidden)Geometry (GeometryList): a list of Part geometries that exist inside the sketch.
  • DataConstraints: named constraints, if they exist; otherwise it is an empty list [].
  • DataExternal Geometry (LinkSubList): a list of Part geometries outside this Sketch that are used for reference.
  • DataFully Constrained (Bool): (read-only) if it is true, the sketch is fully constrained.

View

Auto Constraints

  • ViewAutoconstraints (Bool): if true it will try setting constraints when the geometry is drawn.

Visibility automation

  • ViewEditing Workbench (String): name of the workbench to activate when editing the sketch; it defaults to SketcherWorkbench.
  • ViewHide Dependent (Bool): if true all objects that depend on the sketch are hidden when opening the sketch.
  • ViewRestore Camera (Bool): if true the camera position is saved before opening the sketch, and is restored after closing it.
  • ViewShow Links (Bool): if true all objects used in links to external geometry are shown when opening the sketch.
  • ViewShow Support (Bool): if true all objects this sketch is attached to are shown when opening the sketch.

Hidden properties View

Base

  • ViewProxy (PythonObject): a custom view provider class associated with this object. This only exists for the Python version. See Scripting.

Visibility automation

  • ViewTempo Vis (PythonObject): a custom class associated with this object, that handles hiding and showing other objects when opening and closing the sketch.

All other view properties, including hidden properties, are those of the base Part Feature object.

Scripting

See also: FreeCAD Scripting Basics, and scripted objects.

See Part Feature for the general information on adding objects to the document.

A SketchObject is created with the addObject() method of the document.

import FreeCAD as App

doc = App.newDocument()
obj = App.ActiveDocument.addObject("Sketcher::SketchObject", "Sketch")
obj.Label = "Custom label"

This basic Sketcher::SketchObject doesn't have a Proxy object so it can't be fully used for sub-classing.

Therefore, for Python subclassing, you should create the Sketcher::SketchObjectPython object.

import FreeCAD as App

doc = App.newDocument()
obj = App.ActiveDocument.addObject("Sketcher::SketchObjectPython", "CustomSketch")
obj.Label = "Custom label"